package testapplication.handlers;
 

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.ui.MUIElement;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.basic.MPartStack;
import org.eclipse.e4.ui.model.application.ui.basic.MWindow;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.e4.ui.workbench.modeling.EPartService.PartState;

public class NewPartHandler {

	private static int count = 1;
	
	@Execute
	public void execute(MWindow window, EModelService service, EPartService partService) {
		MUIElement find = service.find("testapplication.partstack.newPartTarget", window);
		MPartStack stack =(MPartStack)find;

		MPart part = partService.createPart("testapplication.partdescriptor.newPart");
		part.setLabel("Part "+count);
		part.setCloseable(true);

		if(stack!=null) {
			stack.setToBeRendered(true);
			stack.setVisible(true);
			stack.getChildren().add(part);
			stack.setSelectedElement(part);
		}

		partService.showPart(part, PartState.ACTIVATE);
		count++;
	}
		
}